## Features



<p>
<a href="screenshots.html">
<img src="images/thumbnail_screenshot.jpg" class="right"/>
</a>
<b>Easy-to-use interface. </b> Modern interface (using the GTK
toolkit) with unlimited undo, full-screen mode, simple interaction,
and quick previews. Click <a href="screenshots.html" 
title="Some screenshots">here</a> for an interface tour with more screenshots.
</p>

<p>
<b>Fast calculations.</b>Since all formulas are compiled to machine
code before being run, you get snappy calculations even on complex
custom formulas. If you have a multi-processor, hyperthreaded, or
multi-core computer, Gnofract 4D will take full advantage of it for
even faster calculations.
</p>

<p>
<a href="images/screenshot_4d.png">
<img src="images/thumbnail_screenshot_4d.jpg" class="left"/></a>
<b>Four dimensions.</b>  
What sets it apart from other fractal programs (and makes it "4D") is
the way that it treats the Mandelbrot and Julia sets as different
views of the same four-dimensional fractal object. This allows you to
create images which are a cross between the two sets and explore
their inter-relationships. If you'd like to know some more about the
maths, you can find details in the user's manual.
</p>

<p>
<b>High quality output.</b> 24-bit color rendering, coloring methods
for smooth gradients, antialiasing, and no limit on output
size. The images below show the difference - the first is generated by
<a href="http://spanky.triumf.ca/www/fractint/fractint.html">
Fractint</a>, the second by Gnofract 4D.
</p>
<p>
<img src="images/fract002-150.gif"/>
<img src="images/gnofract4d-example-150.png"/>
</p>

<p>
<a href="images/screenshot2.png">
<img src="images/thumbnail_screenshot2.jpg" class="right"/>
</a>
<b>Find cool images quickly and share them with other users.</b>
Explorer Mode and AutoZoom help you find interesting parts of the
fractal automatically. You can post the results to the <a
href="http://flickr.com/groups/gnofract4d/pool">user gallery</a> on
the web directly from the program.  
</p>

<p>
<b>Popular and widely used.</b> Over <b>30,000</b> downloads to
date. Actively developed, with over 20 releases over the past 7
years. Currently the most popular fractal program listed on <a
href="http://freshmeat.net/projects/gnofract4d/">freshmeat.net</a>. 
Included in FreeBSD ports tree and Fedora Extras.
</p>

<p>
<img src="images/thumbnail_hotpick.jpg" class="right"/>
<b>Linux Format magazine said: </b>"Hot Pick!... lovely crisp rendering... the
abundance of alternative colour schemes is superb... great fun to just
play around with."
</p>
